require("util.extension.math")
local Vector = require("util.geometry.Vector")

function SmoothNoise(uv)
    local lv = Vector(math.fract(uv.x), math.fract(uv.y))
    local id = Vector(math.floor(uv.x), math.floor(uv.y))
    lv = lv * lv * (3. - lv * 2.)
    local bl = math.fract(math.sin(id.x * 100. + id.y * 6574.) * 5647.)
    local br = math.fract(math.sin((id.x + 1) * 100. + id.y * 6574.) * 5647.)
    local b = math.lerp(bl, br, lv.x)
    local tl = math.fract(math.sin(id.x * 100. + (id.y + 1) * 6574.) * 5647.)
    local tr = math.fract(math.sin((id.x + 1) * 100. + (id.y + 1) * 6574.) * 5647.)
    local t = math.lerp(tl, tr, lv.x)
    return math.lerp(b, t, lv.y)
end

return function(uv)
    local c = SmoothNoise(uv * 4.)
    c = c + SmoothNoise(uv * 8.2) * .5
    c = c + SmoothNoise(uv * 16.7) * .25
    c = c + SmoothNoise(uv * 32.4) * .125
    c = c + SmoothNoise(uv * 64.5) * .0625
    c = c / 2.
    return c
end