if type(debug.getmetatable("").__add) == "function" then return end
debug.getmetatable("").__add = function(a, b)
    return a .. b
end
debug.getmetatable("").__sub = function(a, b)
    return b > 0 and a:sub(1, a:len() - b) or a:sub(1 - b, a:len())
end
local idx = debug.getmetatable("").__index
local resolve_idx = type(idx) == "function" and function(str, n)
    return idx(n)
end or function(str, n)
    return idx[n]
end
debug.getmetatable("").__index = function(str, n)
    return resolve_idx(str, n) or type(n) == "number" and idx["sub"](str, n, n) or rawget(string, n)
end
debug.getmetatable("").__mod = function(a, b)
    return type(b) == "number" and (a or ""):sub(1, b) or type(b) == "table" and (a or ""):format(unpack(b)) or (a or ""):match(b)
end
debug.getmetatable("").__mul = function(a, b)
    local o = ""
    for _ = 1, b do
        o += a
    end
    return o
end
debug.getmetatable("").__bnot = function(a)
    if a:sub(-1) == "%" then
        return tonumber(a:sub(1, -2)) / 100
    end
    return 1
end
debug.getmetatable("").__len = string.len
debug.getmetatable("").__div = string.gmatch
function string.find_last(str, pattern, init, plain)
    local i = str:len() - (init and str:sub(init) or str):reverse():find(pattern:reverse(), 1, plain) + 2
    return i, i + pattern:len()
end
string.count = function(str, pattern)
    if pattern:len() == 1 then
        local c = 0
        for i = 1, str:len() do
            if str:sub(i, i) == pattern then
                c += 1
            end
        end
        return c
    end
    return select(2, str:gsub(pattern, ""))
end

string.toaddress = function (str, size)
    if #str < size then
        error("String too short")
    end
    local offset = ""
    for i = size, 1, -1 do
        local b = string.byte(str:sub(i, i))
        offset = offset .. string.format("%02X", b)
    end
    return tonumber(load("return 0x" .. offset .. "LL")())
end

string.tobytes = function (str, size)
    local offset = ""
    for i = size, 1, -1 do
        local b = string.byte(str:sub(i, i))
        offset = offset .. string.format("%02X", b)
    end
    return offset
end

string.split = function(str, sep)
    local t = {}
    for s in str:gmatch("([^" .. sep .. "]+)") do
        table.insert(t, s)
    end
    return t
end

string.rfind = function(str, pattern)
    local i, h = str:reverse():find(pattern:reverse(), 1, true)
    return i and str:len() - h + 1, i and str:len() - i + 1
end

string.utf8char = function (code)
    if code < 0x80 then
        return string.char(code)
    elseif code < 0x800 then
        return string.char(0xC0 + code / 0x40, 0x80 + code % 0x40)
    elseif code < 0x10000 then
        return string.char(0xE0 + code / 0x1000, 0x80 + code / 0x40 % 0x40, 0x80 + code % 0x40)
    elseif code < 0x110000 then
        return string.char(0xF0 + code / 0x40000, 0x80 + code / 0x1000 % 0x40, 0x80 + code / 0x40 % 0x40, 0x80 + code % 0x40)
    end
end

string.escape = function(str)
    if type(str) ~= "string" then
        return tostring(str)
    end
    local s = ""
    for i = 1, #str do
        local c = str:sub(i, i)
        if c == "\\" then
            s = s .. "\\\\"
        elseif c == "\"" then
            s = s .. "\\\""
        elseif c == "\n" then
            s = s .. "\\n"
        elseif c == "\r" then
            s = s .. "\\r"
        elseif c == "\t" then
            s = s .. "\\t"
        elseif c == "\b" then
            s = s .. "\\b"
        elseif c == "\f" then
            s = s .. "\\f"
        else
            s = s .. c
        end
    end
    return s
end
