return function(width, height, wtype)
    if type(width) == "string" then
        wtype, width, height = width, height, wtype
    end
    local settings = require("util.common.settings")("config/window.json")
    local events = require("util.common.events")
    local gui = import("gui")
    if wtype :find "pos" and settings.get("window", nil) then
        local window = settings.get("window")
        local monitors = require("util.gui.monitors")
        for i = 1, #monitors do
            if math.abs(monitors[i].x, window.x) < 20
                and math.abs(monitors[i].y, window.y) < 20
                and math.abs(monitors[i].w, window.width) < 20
                and math.abs(monitors[i].h, window.height) < 20 then
                gui.position(monitors[i].x, monitors[i].y)
                gui.size(monitors[i].w, monitors[i].h)
                gui.style |= gui.styles.MAXIMIZE
                break
            end
        end
        if window.x ~= -32000 and window.y ~= -32000 then
            gui.position(window.x, window.y)
        end
        gui.size(window.width, window.height)
    elseif wtype :find "center" then
        local primary_monitor = require("util.gui.monitors").primary
        width = width or primary_monitor.w * 0.5
        height = height or primary_monitor.h * 0.5
        local window = settings.get("window", {x = primary_monitor.x + primary_monitor.w * 0.5 - width * 0.5, y = primary_monitor.y + primary_monitor.h * 0.5 - height * 0.5, width = width, height = height})
        gui.position(window.x, window.y)
        gui.size(window.width, window.height)
        if math.abs(window.x - 0) < 20
            and math.abs(window.y - 0) < 20
            and math.abs(window.width - primary_monitor.w) < 20
            and math.abs(window.height - primary_monitor.h) < 20 then
            gui.style |= gui.styles.MAXIMIZE
        end
    elseif wtype :find "fulls" then
        gui.fullscreen = true
    elseif wtype :find "max" then
        local primary_monitor = require("util.gui.monitors").primary
        gui.size(primary_monitor.w, primary_monitor.h)
        gui.style |= gui.styles.MAXIMIZE
    elseif width and height then
        gui.size(width, height)
    end
    if wtype :find "pos" then
        events.shutdown += function()
            printf("Saving window position: %d, %d | %d, %d", gui.x, gui.y, gui.width, gui.height)
            settings.set("window", { x = gui.x, y = gui.y, width = gui.width, height = gui.height })
        end
    end
end